org.apache.ignite.internal.processors.cache.mvcc.txlog

## Class TxLogTree

- java.lang.Object
- - org.apache.ignite.internal.processors.cache.persistence.DataStructure
  - - org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree<TxKey,TxRow>
    - - org.apache.ignite.internal.processors.cache.mvcc.txlog.TxLogTree

All Implemented Interfaces:
  IgniteTree<TxKey,TxRow>

    public class TxLogTree
    extends BPlusTree<TxKey,TxRow>

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`BPlusTree.Get, BPlusTree.Insert, BPlusTree.Invoke, BPlusTree.Put, BPlusTree.Replace, BPlusTree.Result, BPlusTree.Search, BPlusTree.TreeRowClosure<L,T extends L>, BPlusTree.TreeVisitorClosure<L,T extends L>`

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.util.IgniteTree

`IgniteTree.InvokeClosure<T>, IgniteTree.OperationType`

### Field Summary

### Fields inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`CONC_DESTROY_MSG, IGNITE_BPLUS_TREE_LOCK_RETRIES_DEFAULT, metaPageId, suspendFailureDiagnostic, testHndWrapper`

### Fields inherited from class org.apache.ignite.internal.processors.cache.persistence.DataStructure

`grpId, grpName, lockLsnr, metrics, NOOP_LSNR, pageFlag, pageIoRslvr, pageMem, reuseList, rnd, wal`

### Constructor Summary

Constructors
Constructor and Description
`TxLogTree(String name, PageMemory pageMem, IgniteWriteAheadLogManager wal, long metaPageId, ReuseList reuseList, FailureProcessor failureProcessor, boolean initNew, PageLockListener lockLsnr)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected int` `compare(BPlusIO<TxKey> io, long pageAddr, int idx, TxKey row)`
`TxRow` `getRow(BPlusIO<TxKey> io, long pageAddr, int idx, Object ignored)` Get data row.

### Methods inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`acquirePage, checkDestroyed, compare, corruptedTreeException, destroy, destroy, destroyDownPages, enableSequentialWriteMode, find, find, find, findFirst, findFirst, findLast, findLast, findOne, findOne, findOne, getFirstPageIds, getLockRetries, getMetaPageId, getName, getRow, initTree, initTree, interruptAll, invoke, isEmpty, iterate, latestInnerIO, latestLeafIO, markDestroyed, maxLockHoldTime, printTree, processFailure, put, putx, read, read, remove, removex, rootLevel, setIos, size, size, statisticsHolder, temporaryReleaseLock, toString, treeName, validateTree, visit`

### Methods inherited from class org.apache.ignite.internal.processors.cache.persistence.DataStructure

`acquirePage, allocatePage, allocatePage, allocatePageNoReuse, groupId, init, needWalDeltaRecord, pageSize, randomInt, read, read, readLock, readUnlock, recyclePage, releasePage, tryWriteLock, write, write, write, write, writeLock, writeUnlock, writeUnlock`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### TxLogTree

    public TxLogTree(String name,
                     PageMemory pageMem,
                     IgniteWriteAheadLogManager wal,
                     long metaPageId,
                     ReuseList reuseList,
                     FailureProcessor failureProcessor,
                     boolean initNew,
                     PageLockListener lockLsnr)
              throws IgniteCheckedException

Parameters:
  `pageMem` - Page memory.
  `wal` - Write ahead log manager
  `metaPageId` - Tree metapage id.
  `reuseList` - Reuse list
  `failureProcessor` - Failure processor.
  `initNew` - `True` if new tree should be created.
Throws:
  `IgniteCheckedException` - If fails.

### Method Detail

#### compare

    protected int compare(BPlusIO<TxKey> io,
                          long pageAddr,
                          int idx,
                          TxKey row)

Specified by:
  `compare` in class `BPlusTree<TxKey,TxRow>`
Parameters:
  `io` - IO.
  `pageAddr` - Page address.
  `idx` - Index of row in the given buffer.
  `row` - Lookup row.
Returns:
  Comparison result as in `Comparator.compare(Object, Object)`.

#### getRow

    public TxRow getRow(BPlusIO<TxKey> io,
                        long pageAddr,
                        int idx,
                        Object ignored)
                 throws IgniteCheckedException

Get data row. Can be called on inner page only if `BPlusTree.canGetRowFromInner` is `true`.

Specified by:
  `getRow` in class `BPlusTree<TxKey,TxRow>`
Parameters:
  `io` - IO.
  `pageAddr` - Page address.
  `idx` - Index.
  `ignored` - Implementation specific argument, `null` always means that we need to return full detached data row.
Returns:
  Data row.
Throws:
  `IgniteCheckedException` - If failed.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.11.0
Release Date | : September 11 2021